=== debian/changelog ===
castle-game-engine (6.0.2+dfsg1-2) experimental; urgency=medium

  * Improve the FTBFS on arm64 by adding it to the list of archs
  * Fix FTBFS on armel, armhf and powerpc in test-suite with upstream
    patch to change epsilon
  * Install examples into castle-game-engine-doc
  * Add upstream patch to enable generating all man-pages during build
    (instead of requiring an x-server session to do so)

 -- Paul Gevers <elbrus@debian.org>  Fri, 31 Mar 2017 20:19:13 +0200

castle-game-engine (6.0.2+dfsg1-1) experimental; urgency=medium

  * New upstream release
    - Adapt to new layout of the source
    - Refresh patches and remove obsolete ones
  * Update d/copyright for new upstream version
    - Strip convenience copies without source with the aid of d/watch
  * Update d/watch for new upstream location and Files-Excluded support
  * Bump compat level to 10
  * Update upstream homepage
  * Replace obsolete -s option in dh-* calls with -a in d/rules
  * Improve the copying of the src code
  * Ship the tools that are part of cge in fp-units-castle-game-engine
  * generate auto-generated files in d/rules
  * Improve Debian situation for builders of Android applications
  * Depend on libjs-jquery for documentation (added by pasdoc)

 -- Paul Gevers <elbrus@debian.org>  Fri, 24 Mar 2017 15:43:33 +0100
