=== debian/watch ===
version=4
opts=\
compression=xz,\
repack,\
repacksuffix=+dfsg1,\
dversionmangle=s/\+dfsg(\d*)//,\
"filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%castle-game-$1.tar.xz%" \
    https://github.com/castle-engine/castle-engine/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian
