## castle-game-engine 6.2+dfsg1

=== Makefile ===
--- 
+++ 
@@ -32,6 +32,7 @@
 #     - Delphi backup files (*.~???)
 #     - pasdoc generated documentation in doc/pasdoc/ and doc/reference/
 #     - closed-source libs you may have left in tools/build-tool/data
+#     - QtCreator *.pro.user
 #     This is a useful step when packing the release of CGE.
 #
 #   cleanall --
@@ -110,15 +111,23 @@
 	       $(BINDIR)/sprite-sheet-to-x3d
 	rm -Rf $(DATADIR)/castle-engine
 
-# Strip libraries that cannot be distributed in Debian package of CGE for now,
-# because they (possibly) cannot be recompiled by Debian software right now
-# (or maybe they can, but noone had time to try it yet, and wrap in a script).
-# This concerns some Windows and Android libs.
+# Strip libraries that cannot be distributed in Debian package of CGE.
+# - Some of them (some bundled Windows, Android libs) cannot be recompiled
+#   automatically and easily for now (although they are open-source),
+#   and are not of sufficient interest to the Debian users.
+# - Some (Gradle) should be better used by depending on
+#   the appropriate Debian package.
 .PHONY: strip-precompiled-libraries
 strip-precompiled-libraries:
 	rm -Rf tools/build-tool/data/external_libraries/ \
-	       tools/build-tool/data/android/integrated-components/sound/ \
-	       tools/build-tool/data/android/integrated-components/ogg_vorbis/
+	       tools/build-tool/data/android/integrated-services/sound/ \
+	       tools/build-tool/data/android/integrated-services/ogg_vorbis/ \
+	       tools/build-tool/data/android/base/gradle/ \
+	       tools/build-tool/data/android/base/gradlew \
+	       tools/build-tool/data/android/base/gradlew.bat \
+	       tools/build-tool/data/android/integrated/gradle/ \
+	       tools/build-tool/data/android/integrated/gradlew \
+	       tools/build-tool/data/android/integrated/gradlew.bat
 
 # examples and tools -----------------------------------------------------------
 
@@ -154,6 +163,7 @@
   examples/fonts/font_from_texture \
   examples/fonts/test_local_characters/test_local_characters \
   examples/fonts/html_text \
+  examples/fonts/font_draw_over_image \
   examples/tiled/tiled_demo_standalone \
   examples/window/window_events \
   examples/window/window_menu \
@@ -192,8 +202,7 @@
   examples/3d_rendering_processing/cars_demo \
   examples/3d_rendering_processing/render_3d_to_texture_and_use_as_quad \
   src/x3d/teapot/teapot_3d_to_pascal \
-  src/x3d/nodes_specification/x3d_nodes_spec_to_pascal/x3d_nodes_spec_to_pascal \
-  src/x3d/nodes_specification/generate_x3d_nodes_helpers/generate_x3d_nodes_to_pascal \
+  src/x3d/nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal \
   examples/fixed_camera_game/rift \
   examples/isometric_game/sandbox \
   examples/3d_sound_game/lets_take_a_walk \
@@ -201,9 +210,10 @@
   examples/resource_animations/resource_animations \
   examples/fps_game/fps_game \
   examples/2d_standard_ui/show_various_ui_controls/show_various_ui_controls \
+  examples/2d_standard_ui/edit_test/edit_test \
   examples/2d_standard_ui/timer_test/timer_test \
   examples/2d_standard_ui/zombie_fighter/zombie_fighter \
-  examples/android/android_demo/androiddemo_standalone \
+  examples/mobile/simple_3d_demo/simple_3d_demo_standalone \
   tools/build-tool/castle-engine \
   tools/image-to-pascal/image-to-pascal \
   tools/texture-font-to-pascal/texture-font-to-pascal \
@@ -214,13 +224,14 @@
 
 EXAMPLES_LAZARUS_BASE_NAMES := \
   examples/audio/test_al_source_allocator \
+  examples/audio/audio_player_scrubber/audio_player_scrubber \
   examples/lazarus/model_3d_viewer/model_3d_viewer \
   examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
   examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
   examples/lazarus/two_controls/two_controls \
   tests/test_castle_game_engine \
   src/library/castleengine \
-  examples/library/lcl_dynlib_tester/cge_dynlib_tester \
+  examples/library/lazarus_library_tester/cge_dynlib_tester \
   examples/random_generator/graphics_random_test
 
 EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
@@ -262,16 +273,3 @@
 .PHONY: clean cleanmore cleanall
 
 clean: cleanexamples
-	$(FIND) . -type f '(' -iname '*.ow'  -or -iname '*.ppw' -or -iname '*.aw' -or \
-	                   -iname '*.o'   -or -iname '*.ppu' -or -iname '*.a' -or \
-			   -iname '*.or'  -or \
-			   -iname '*.rsj' -or \
-			   -iname '*.compiled' -or \
-			   -iname '*.lps' -or \
-			   -iname '*.libimp*.a' -or \
-			   -iname '*.apk' -or \
-	                   -iname '*.dcu' -or -iname '*.dpu' -or \
-	                   -iname '*.log' -or \
-			   -iname 'castleengine.dll' -or -iname 'libcastleengine.so' ')' \
-	     -print \
-	     | xargs rm -f
