=== debian/changelog ===
castle-game-engine (6.2+dfsg1-4) unstable; urgency=medium

  * Set FPCDIR on armel/armhf until fpc bug #888697 is fixed

 -- Paul Gevers <elbrus@debian.org>  Fri, 02 Feb 2018 13:19:20 +0100

castle-game-engine (6.2+dfsg1-3) unstable; urgency=medium

  * Fix FTBFS arch:all (without building arch:any at the same time)

 -- Paul Gevers <elbrus@debian.org>  Sun, 28 Jan 2018 19:42:59 +0100

castle-game-engine (6.2+dfsg1-2) unstable; urgency=medium

  * Don't set FPCDIR in d/rules (Closes: #887575)
  * Add patch for reproducible builds (Closes: #868790) Thanks Lamby.
  * Bump dephelper compat level to 11 and set Rules-Requires-Root to no

 -- Paul Gevers <elbrus@debian.org>  Sun, 28 Jan 2018 13:09:54 +0100

castle-game-engine (6.2+dfsg1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream release
  * Refresh patches: drop most as they were from upstream

 -- Paul Gevers <elbrus@debian.org>  Wed, 12 Jul 2017 21:26:19 +0200
