=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders:
  Abou Al Montacir <abou.almontacir@sfr.fr>,
  Paul Gevers <elbrus@debian.org>
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Build-Depends:
- debhelper (>= 10~),
+ debhelper (>= 11~),
  dh-exec,
  fonts-dejavu,
  fp-compiler,
@@ -32,9 +32,10 @@
 Build-Depends-Indep:
  inkscape,
  pasdoc (>= 0.14.0),
-Vcs-Git: https://anonscm.debian.org/git/pkg-pascal/castle-game-engine.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-pascal/castle-game-engine.git
+Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
+Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine.git
 Homepage: https://castle-engine.sourceforge.io/engine.php
+Rules-Requires-Root: no
 
 Package: fp-units-castle-game-engine
 Architecture: any
