=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,8 @@
 #!/usr/bin/make -f
 # debian/rules for Castle Game Engine
 
-DEB_PACKAGE_NAME=castle-game-engine
+include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/pkg-info.mk
 export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
 export LANG:=C
 
@@ -24,23 +25,19 @@
 CPU_TARGET?=$(shell ${FPC} -iTP)
 OS_TARGET?=$(shell ${FPC} -iTO)
 FPCTARGET=${CPU_TARGET}-${OS_TARGET}
-# Get version information from changelog file
-DEB_VERSION:=$(shell dpkg-parsechangelog | grep '^Version:' | cut -f 2 -d ' ')
-DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
 # Used in dh-exec enhanced files
-export CGE_VERSION=${DEB_UPSTREAM_VERSION}
-DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
+export CGE_VERSION=${DEB_VERSION_UPSTREAM}
+DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_VERSION_UPSTREAM} | sed -e 's/^\([0-9\.]*\).*/\1/')
 DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
 ifndef PACKAGESUFFIX
 PACKAGESUFFIX=-${DEB_UPSTREAM_MAIN_VERSION}
 endif
-DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 # Get directories
 CURDIR:=$(shell pwd)
 INSTALL_DIR=$(CURDIR)/debian/tmp
-LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
-SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
-UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
+LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_SOURCE}/${DEB_UPSTREAM_MAIN_VERSION}
+SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_SOURCE}-${DEB_UPSTREAM_MAIN_VERSION}
+UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_SOURCE}-${DEB_UPSTREAM_MAIN_VERSION}
 TMP_DIR=${INSTALL_DIR}/tmp
 # Get utils
 ifndef MKDIR
@@ -54,19 +51,20 @@
 ifndef FPCMAKE
 FPCMAKE=fpcmake
 endif
-# Define FPCDIR if it was not set
-ifndef FPCDIR
-export FPCDIR=/usr/lib/fpc/${FPCVER}
-endif
 ifndef LAZBUILD
 LAZBUILD=lazbuild
 endif
 # Set default compilation options
 BUILDOPTS=
 
-# Until we switch to shorthand dh, we need to set this ourselves for
-# reproducible builds
-export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)
+# Until bug #888697 against fpc is fixed, we need to specify the FPCDIR on
+# armel and armhf
+ifeq ($(DEB_HOST_ARCH),armel)
+export FPCDIR=/usr/lib/arm-linux-gnueabi/fpc/${FPCVER}
+endif
+ifeq ($(DEB_HOST_ARCH),armhf)
+export FPCDIR=/usr/lib/arm-linux-gnueabihf/fpc/${FPCVER}
+endif
 
 #export DH_VERBOSE=1
 
@@ -120,9 +118,9 @@
 
 	# Upstream source contains auto-generated include files. Let's generate
 	# them again.
-	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg src/x3d/nodes_specification/generate_x3d_nodes_helpers/generate_x3d_nodes_to_pascal.lpr
-	cd src/x3d/nodes_specification/generate_x3d_nodes_helpers ; \
-		PATH=${TMP_DIR} generate_x3d_nodes_to_pascal ../components/*.txt
+	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg src/x3d/nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr
+	cd src/x3d/nodes_specification/x3d-nodes-to-pascal ; \
+		PATH=${TMP_DIR} x3d-nodes-to-pascal ../components/*.txt
 
 	# For reproducible builds we need to make sure the timestamp of the just
 	# created files is fixed. Let's use SOURCE_DATE_EPOCH for that. For the
@@ -194,7 +192,7 @@
 	touch install-arch-stamp
 
 build-indep: configure prepare-source install-source build-doc
-install-indep: install-doc install-source
+install-indep: install-source install-doc
 
 ###################
 # Documentation
@@ -227,7 +225,7 @@
 # Annoying thing is we need to do this very early to save lots of overhead. If
 # it can be done on a clean tree, right after prepare-source we don't need
 # cleaning, right.
-install-source: install-source-stamp
+install-source: prepare-source install-source-stamp
 install-source-stamp:
 	@echo "--- Copying the source code"
 	dh_testdir
@@ -263,3 +261,7 @@
 	dh_lintian
 
 ifeq (${DEB_BUILD},0)
+	# We are building upstream debs, install override files for build = 0
+	set -x -e ; cd debian ; for PACKAGE in `sed -n -e 's/Package: \(.*\)/\1/p' control` ; do \
+	  if [ -d $${PACKAGE} ] ; \
+	  then \
