=== src/x3d/teapot/Makefile ===
teapot.inc: teapot.wrl
	./teapot_3d_to_pascal teapot.wrl > teapot.inc

.PHONY: clean
clean:
	rm -f teapot.inc
