=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders:
  Abou Al Montacir <abou.almontacir@sfr.fr>,
  Paul Gevers <elbrus@debian.org>
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 13),
  dh-exec,
  fonts-dejavu,
  fp-compiler,
@@ -21,6 +21,7 @@
  fp-units-net,
  fp-utils (>= 2.6.2),
  help2man,
+ imagemagick,
  libatk1.0-dev,
  libcairo2-dev,
  libfreetype6-dev,
@@ -28,12 +29,11 @@
  libgtk2.0-dev,
  libgtkglext1-dev,
  libpango1.0-dev,
- xcftools,
 Build-Depends-Indep:
- inkscape,
- pasdoc (>= 0.14.0),
+ inkscape (>= 1.0~),
+ pasdoc (>= 0.15.0~),
 Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
-Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine.git
+Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine
 Homepage: https://castle-engine.sourceforge.io/engine.php
 Rules-Requires-Root: no
 
@@ -74,11 +74,14 @@
 Section: doc
 Architecture: all
 Depends:
- ${misc:Depends}
+ ${misc:Depends},
+ fonts-droid-fallback,
+ fonts-dejavu-core,
 Suggests:
  castle-game-engine-src,
  fp-units-castle-game-engine,
  libjs-jquery,
+Multi-Arch: foreign
 Description: Castle Game Engine - Developer's Documentation
  Castle Game Engine is a set of LGPL licenced libraries that are intended to
  ease developing 3D games with FreePascal / Lazarus.
@@ -103,6 +106,7 @@
  lazarus
 Suggests:
  fp-units-castle-game-engine
+Multi-Arch: foreign
 Description: Castle Game Engine - Source code for Lazarus integration
  Castle Game Engine is a set of LGPL licenced libraries that are intended to
  ease developing 3D games with FreePascal / Lazarus.
